#include "stc32g.h"
#include "stdio.h"
#include "intrins.h"

#define FOSC            12000000UL
#define PLLCLK          144000000UL

#define MCLKDIV         4               //144M/4=36M
//#define MCLKDIV       5               //144M/5=28.8M

#define MCLK            PLLCLK
#define SYSCLK          MCLK/MCLKDIV

#define BAUD            (65536 - SYSCLK/4/115200)

#define MCLK_HIRC       0
#define MCLK_IRC32K     1
#define MCLK_IRC48M     2
#define MCLK_XOSC       3
#define MCLK_X32K       4
#define MCLK_PLL        5
#define MCLK_PLLD2      6
#define MCLK_SEL        MCLK_PLL

#define HSCK_MCLK       0
#define HSCK_PLL        1
#define HSCK_SEL        HSCK_PLL

#define PLL_96M         0
#define PLL_144M        1
#define PLL_SEL         PLL_144M

#define CKMS            0x80
#define HSIOCK          0x40
#define MCK2SEL_MSK     0x0c
#define MCK2SEL_SEL1    0x00
#define MCK2SEL_PLL     0x04
#define MCK2SEL_PLLD2   0x08
#define MCK2SEL_IRC48   0x0c
#define MCKSEL_MSK      0x03
#define MCKSEL_HIRC     0x00
#define MCKSEL_XOSC     0x01
#define MCKSEL_X32K     0x02
#define MCKSEL_IRC32K   0x03

#define ENCKM           0x80
#define PCKI_MSK        0x60
#define PCKI_D1         0x00
#define PCKI_D2         0x20
#define PCKI_D4         0x40
#define PCKI_D8         0x60

void delay()
{
    int i;
    
    for (i=0; i<100; i++);
}

char ReadPWMA(char addr)
{
    char dat;
    
    while (HSPWMA_ADR & 0x80);              //ȴǰһ첽д
    HSPWMA_ADR = addr | 0x80;               //üӷʵַ,ֻҪԭXFRַĵ7λ
                                            //HSPWMA_ADDRĴλд1,ʾ
    while (HSPWMA_ADR & 0x80);              //ȴǰ첽ȡ
    dat = HSPWMA_DAT;                       //ȡ첽
    
    return dat;
}

void WritePWMA(char addr, char dat)
{
    while (HSPWMA_ADR & 0x80);              //ȴǰһ첽д
    HSPWMA_DAT = dat;                       //׼Ҫд
    HSPWMA_ADR = addr & 0x7f;               //üӷʵַ,ֻҪԭXFRַĵ7λ
                                            //HSPWMA_ADDRĴλд0,ʾд
}

char ReadPWMB(char addr)
{
    char dat;
    
    while (HSPWMB_ADR & 0x80);              //ȴǰһ첽д
    HSPWMB_ADR = addr | 0x80;               //üӷʵַ,ֻҪԭXFRַĵ7λ
                                            //HSPWMB_ADDRĴλд1,ʾ
    while (HSPWMB_ADR & 0x80);              //ȴǰ첽ȡ
    dat = HSPWMB_DAT;                       //ȡ첽
    
    return dat;
}

void WritePWMB(char addr, char dat)
{
    while (HSPWMB_ADR & 0x80);              //ȴǰһ첽д
    HSPWMB_DAT = dat;                       //׼Ҫд
    HSPWMB_ADR = addr & 0x7f;               //üӷʵַ,ֻҪԭXFRַĵ7λ
                                            //HSPWMB_ADDRĴλд0,ʾд
}

void main()
{
    WTST = 0x00;
    P_SW2 = 0x80;
    
    P0M0 = 0x00; P0M1 = 0x00;
    P1M0 = 0x00; P1M1 = 0x00;
    P2M0 = 0x00; P2M1 = 0x00;
    P3M0 = 0x00; P3M1 = 0x00;
    P5M0 = 0x10; P5M1 = 0x00;
    
    SCON = 0x52;
    AUXR = 0x40;
    TMOD = 0x00;
    TL1 = BAUD;
    TH1 = BAUD >> 8;
    TR1 = 1;
    
    //ѡPLLʱ
#if (PLL_SEL == PLL_96M)
    CLKSEL &= ~CKMS;                        //ѡPLL96MΪPLLʱ
#elif (PLL_SEL == PLL_144M)
    CLKSEL |= CKMS;                         //ѡPLL144MΪPLLʱ
#else
    CLKSEL &= ~CKMS;                        //ĬѡPLL96MΪPLLʱ
#endif
    
    //ѡPLLʱӷƵ,֤ʱΪ12M
    USBCLK &= ~PCKI_MSK;
#if (FOSC == 12000000UL)
    USBCLK |= PCKI_D1;                      //PLLʱ1Ƶ
#elif (FOSC == 24000000UL)
    USBCLK |= PCKI_D2;                      //PLLʱ2Ƶ
#elif (FOSC == 48000000UL)
    USBCLK |= PCKI_D4;                      //PLLʱ4Ƶ
#elif (FOSC == 96000000UL)
    USBCLK |= PCKI_D8;                      //PLLʱ8Ƶ
#else
    USBCLK |= PCKI_D1;                      //ĬPLLʱ1Ƶ
#endif

    //PLL
    USBCLK |= ENCKM;                        //ʹPLLƵ
    
    delay();                                //ȴPLLƵ
    
    //ѡʱԴ
    CLKDIV = MCLKDIV;                       //ʱѡƵǰ,÷Ƶϵ,ᵱ
    
    CLKSEL &= ~MCKSEL_MSK;
    CLKSEL &= ~MCK2SEL_MSK;
#if (MCLK_SEL == MCLK_HIRC)
    CLKSEL |= MCKSEL_HIRC;                  //ѡڲIRCΪʱ
    CLKSEL |= MCK2SEL_SEL1;                 //ѡMCKSELѡʱΪʱ
#elif (MCLK_SEL == MCLK_IRC32K)
    CLKSEL |= MCKSEL_X32K;                  //ѡⲿ32KΪʱ
    CLKSEL |= MCK2SEL_SEL1;                 //ѡMCKSELѡʱΪʱ
#elif (MCLK_SEL == MCLK_IRC48M)
    CLKSEL |= MCKSEL_HIRC;                  //ѡڲIRCΪʱ
    CLKSEL |= MCK2SEL_IRC48;                //ѡڲ48MIRCΪʱ
#elif (MCLK_SEL == MCLK_XOSC)
    CLKSEL |= MCKSEL_XOSC;                  //ѡⲿپΪʱ
    CLKSEL |= MCK2SEL_SEL1;                 //ѡMCKSELѡʱΪʱ
#elif (MCLK_SEL == MCLK_X32K)
    CLKSEL |= MCKSEL_IRC32K;                //ѡڲIRCΪʱ
    CLKSEL |= MCK2SEL_SEL1;                 //ѡMCKSELѡʱΪʱ
#elif (MCLK_SEL == MCLK_PLL)
    CLKSEL |= MCKSEL_HIRC;                  //ѡڲIRCΪʱ
    CLKSEL |= MCK2SEL_PLL;                  //ѡPLLʱΪʱ
#elif (MCLK_SEL == MCLK_PLLD2)
    CLKSEL |= MCKSEL_HIRC;                  //ѡڲIRCΪʱ
    CLKSEL |= MCK2SEL_PLLD2;                //ѡPLLʱ2ƵʱΪʱ
#else
    CLKSEL |= MCKSEL_HIRC;                  //ĬѡڲIRCΪʱ
    CLKSEL |= MCK2SEL_SEL1;                 //ĬѡMCKSELѡʱΪʱ
#endif

    MCLKOCR = 0x04;                         //ϵͳʱ4ƵP5.4

    //ѡHSPWM/HSSPIʱ
#if (HSCK_SEL == HSCK_MCLK)
    CLKSEL &= ~HSIOCK;                      //HSPWM/HSSPIѡʱΪʱԴ
#elif (HSCK_SEL == HSCK_PLL)
    CLKSEL |= HSIOCK;                       //HSPWM/HSSPIѡPLLʱΪʱԴ
#else
    CLKSEL &= ~HSIOCK;                      //ĬHSPWM/HSSPIѡʱΪʱԴ
#endif

    HSCLKDIV = 0;                           //HSPWM/HSSPIʱԴƵ
    
    HSPWMA_CFG = 0x03;                      //ʹPWMAؼĴ첽ʹ
    HSPWMB_CFG = 0x03;                      //ʹPWMBؼĴ첽ʹ
    
    PWMA_PS = 0x01;                         //PWMA_CC1PWMP2.0
                                            //PWMB_CC5P2.0ڽв

    //ͨ첽ʽPWMA/PWMBؼĴ
    WritePWMA((char)&PWMA_CCER1, 0x00);
    WritePWMA((char)&PWMA_CCMR1, 0x00);     //CC1Ϊģʽ
    WritePWMA((char)&PWMA_CCMR1, 0x60);     //OC1REFPWM1(CNT<CCRʱЧƽ1)
    WritePWMA((char)&PWMA_CCER1, 0x05);     //ʹCC1/CC1Nϵ
    WritePWMA((char)&PWMA_ENO, 0x03);       //ʹPWMź˿
    WritePWMA((char)&PWMA_BKR, 0x80);       //ʹ
    WritePWMA((char)&PWMA_CCR1H, 0x00);     //PWMռձ
    WritePWMA((char)&PWMA_CCR1L, 0x02);
    WritePWMA((char)&PWMA_ARRH, 0x00);      //PWM
    WritePWMA((char)&PWMA_ARRL, 0x04);
    WritePWMA((char)&PWMA_CR1, 0x01);       //ʼPWM

    WritePWMB((char)&PWMB_CCER1, 0x00);
    WritePWMB((char)&PWMB_CCMR1, 0x01);     //CC5Ϊģʽ,ӳ䵽TI5FP5
    WritePWMB((char)&PWMB_CCMR2, 0x02);     //CC6Ϊģʽ,ӳ䵽TI6FP5
    WritePWMB((char)&PWMB_CCER1, 0x31);     //ʹCC5ϵĲ(ز)
    WritePWMB((char)&PWMB_SMCR, 0x54);      //ظλģʽ
    WritePWMB((char)&PWMB_CR1, 0x01);       //ʼPWM
    
    while (1)
    {
        if (ReadPWMB((char)&PWMB_SR1) & 0x02)   //ȴ
        {
            WritePWMB((char)&PWMB_SR1, 0x00);   //ɱ־
            
            //ȡ񵽵ֵ
            printf("%02x", (unsigned int)ReadPWMB((char)&PWMB_CCR5H) & 0xff);
            printf("%02x", (unsigned int)ReadPWMB((char)&PWMB_CCR5L) & 0xff);
            printf(" ");
            
            //ȡ񵽵ռձֵ
            printf("%02x", (unsigned int)ReadPWMB((char)&PWMB_CCR6H) & 0xff);
            printf("%02x", (unsigned int)ReadPWMB((char)&PWMB_CCR6L) & 0xff);
            printf("\n");
        }
    }
}
